Package org.apache.commons.math3.ode

# Class ContinuousOutputFieldModel<T extends RealFieldElement<T>>

java.lang.Object
org.apache.commons.math3.ode.ContinuousOutputFieldModel<T>

Type Parameters:
  `T` - the type of the field elements

All Implemented Interfaces:
  `FieldStepHandler<T>`

public class ContinuousOutputFieldModel<T extends RealFieldElement<T>> extends Object implements FieldStepHandler<T>
This class stores all information provided by an ODE integrator during the integration process and build a continuous model of the solution from this.

This class act as a step handler from the integrator point of view. It is called iteratively during the integration process and stores a copy of all steps information in a sorted collection for later use. Once the integration process is over, the user can use the `getInterpolatedState` method to retrieve this information at any time. It is important to wait for the integration to be over before attempting to call `getInterpolatedState(RealFieldElement)` because some internal variables are set only once the last step has been handled.

This is useful for example if the main loop of the user application should remain independent from the integration process or if one needs to mimic the behaviour of an analytical model despite a numerical model is used (i.e. one needs the ability to get the model value at any time or to navigate through the data).

If problem modeling is done with several separate integration phases for contiguous intervals, the same ContinuousOutputModel can be used as step handler for all integration phases as long as they are performed in order and in the same direction. As an example, one can extrapolate the trajectory of a satellite with one model (i.e. one set of differential equations) up to the beginning of a maneuver, use another more complex model including thrusters modeling and accurate attitude control during the maneuver, and revert to the first model after the end of the maneuver. If the same continuous output model handles the steps of all integration phases, the user do not need to bother when the maneuver begins or ends, he has all the data available in a transparent manner.

One should be aware that the amount of data stored in a ContinuousOutputFieldModel instance can be important if the state vector is large, if the integration interval is long or if the steps are small (which can result from small tolerance settings in `adaptive step size integrators`).

Since:
  3.6
See Also:
  - `FieldStepHandler`
  - `FieldStepInterpolator`

## Constructor Summary

Constructors
Constructor
Description
`ContinuousOutputFieldModel()`
Simple constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`append(ContinuousOutputFieldModel<T> model)`
Append another model at the end of the instance.
`T`
`getFinalTime()`
Get the final integration time.
`T`
`getInitialTime()`
Get the initial integration time.
`FieldODEStateAndDerivative<T>`
`getInterpolatedState(T time)`
Get the state at interpolated time.
`void`
`handleStep(FieldStepInterpolator<T> interpolator, boolean isLast)`
Handle the last accepted step.
`void`
`init(FieldODEStateAndDerivative<T> initialState, T t)`
Initialize step handler at the start of an ODE integration.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ContinuousOutputFieldModel

public ContinuousOutputFieldModel()
Simple constructor. Build an empty continuous output model.

## Method Details

### append

public void append(ContinuousOutputFieldModel<T> model) throws MathIllegalArgumentException, MaxCountExceededException
Append another model at the end of the instance.

Parameters:
  `model` - model to add at the end of the instance
Throws:
  `MathIllegalArgumentException` - if the model to append is not compatible with the instance (dimension of the state vector, propagation direction, hole between the dates)
  `DimensionMismatchException` - if the dimensions of the states or the number of secondary states do not match
  `MaxCountExceededException` - if the number of functions evaluations is exceeded during step finalization

### init

public void init(FieldODEStateAndDerivative<T> initialState, T t)
Initialize step handler at the start of an ODE integration.

This method is called once at the start of the integration. It may be used by the step handler to initialize some internal data if needed.

Specified by:
  `init` in interface `FieldStepHandler<T extends RealFieldElement<T>>`
Parameters:
  `initialState` - initial time, state vector and derivative
  `t` - target time for the integration

### handleStep

public void handleStep(FieldStepInterpolator<T> interpolator, boolean isLast) throws MaxCountExceededException
Handle the last accepted step. A copy of the information provided by the last step is stored in the instance for later use.

Specified by:
  `handleStep` in interface `FieldStepHandler<T extends RealFieldElement<T>>`
Parameters:
  `interpolator` - interpolator for the last accepted step.
  `isLast` - true if the step is the last one
Throws:
  `MaxCountExceededException` - if the number of functions evaluations is exceeded during step finalization

### getInitialTime

public T getInitialTime()
Get the initial integration time.

Returns:
  initial integration time

### getFinalTime

public T getFinalTime()
Get the final integration time.

Returns:
  final integration time

### getInterpolatedState

public FieldODEStateAndDerivative<T> getInterpolatedState(T time)
Get the state at interpolated time.

Parameters:
  `time` - time of the interpolated point
Returns:
  state at interpolated time